//********************************************************************************************
/**
 * @file		main.cpp
 * @brief		v
	
		̃t@C̏ڍא
 * 
 * @author		N.Takeda
 * @date		2011/06/08() 10:29:13
 */
//********************************************************************************************

#include <windows.h>
#include <stdio.h>

#include <commctrl.h>
#include <tools.h>
#include <files/xcopy.h>
#include <system/ezParam.h>
#include "wavvol.h"

#include "resource.h"

/// O[o\̂̒`.
#include "struct.h"


#define	BAI		1

int		dotn = 50000 / BAI;
float	xstep = 0.01f * BAI;
int		yframe = 100;
int		yrng = 10000;


void	TextOut( HDC DC,int x, int y, char *str)
{
	TextOut( DC,x,y,str,lstrlen(str) );
}


/// eXgĐpJE^.
int			iSyncFrm;

int					iVolPerFrame;
WAVEVOL::EnDataKind	eKind;
int					iPer = 40;

#if 0
BOOL		flg_header;
int			head_data;
int			head_size;
int			outmode = 0;
#endif


extern	int		s_iLengthVolume;		///< {[f[^̃f[^.

static	char	s_sTargetFileName[ _MAX_PATH ];

WAVEVOL			cWavVol;

/// AvP[V[J̕ϐ.
WINDOW_INFO		s_cWin;
STRUCT_GLOBAL	stgl;



void	ReadData( LPCTSTR _pVolFileName );
void	FreeData();
Int32	GetVolData( Int32 _ii );
void	Update( Int32 _iFrame );



//------------------------------------------------------
//		Windowsb֐									
//------------------------------------------------------
static BOOL Init_Window( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdLine,int cmdShow );
static void Init_MainWnd();
static void Init_ChildWnd();
static void Init_SystemMenu();
static long FAR PASCAL MainWndProc( HWND hWnd,UINT message,UINT wParam,LONG lParam );

//------------------------------------------------------
//		WindowsMessage									
//------------------------------------------------------
static void MyWmCreate( HWND hWnd );
static void MyWmClose( HWND hWnd );
static void MyWmPaint( HWND hWnd );
static void MyWmDropFiles( HWND _hWnd, HDROP _hDrop );
static void MyWmCommand( HWND hWnd,WPARAM wParam,LPARAM lParam );

//------------------------------------------------------
//		Timer֘A										
//------------------------------------------------------
static void TimerStart( HWND hWnd );
static void TimerStop();
static void CALLBACK TimerFunc( UINT wID,UINT wUser,DWORD dwUser,DWORD dw1,DWORD dw2 );

//------------------------------------------------------
//		֐											
//------------------------------------------------------
static void Draw_Picture( HDC DC,int X,int Y);
static void Data_Initialize();
void	Data_show();
static void Data_get();
static void Push_start(HWND hWnd);
void	out_volume();
static BOOL StartTimerLoop( HWND hWnd );
static void Read_profile();
void	write_profile();
static void Button_enable( BOOL show );


int		GetVolData(int ii);
void	InfoDraw();
void	InfoDraw(HDC DC, int x1, int y1);
void	VolDraw(HDC DC, int x1, int y1, double* InW);
void	BarDraw(HDC DC, int x1, int y1,int ii);


////////////////////////////////////////////////////////////////
//      ꂪCvOł                            //
////////////////////////////////////////////////////////////////
int PASCAL WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdLine,int cmdShow )
{
	
#if 0
	char	Temp[_MAX_PATH];
	
	CmdLine_Parameter( lpszCmdLine,Temp );		// R}hC̈擾
	if(Temp[0] != 0){
		commandline(Temp);
		return 0;
	}
#endif
	
	MSG	  msg;
	
	if( Init_Window( hInstance,hPrevInstance,lpszCmdLine,cmdShow ) )
	{
		while( GetMessage( &msg,NULL,0,0 ) ){
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		
		return msg.wParam;
	}
	
	FreeData();
	
	WINDOW_Destroy( s_cWin );
	return 0;
}


////////////////////////////////////////////////////////
//      EBhECjVCY                      //
////////////////////////////////////////////////////////
static BOOL Init_Window( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdLine,int cmdShow )
{
	char	Temp[_MAX_PATH], drive[_MAX_DRIVE], dir[_MAX_DIR];
	
	
	if( !hPrevInstance )
	{
		stgl.hInst = hInstance;
		
		// ƃfBNgm
		GetModuleFileName( stgl.hInst, Temp, sizeof(Temp) );
		FILE_split( Temp, drive, dir, NULL, NULL );
		FILE_merge( stgl.MainPath, drive, dir, NULL, NULL );
		
		Init_MainWnd();
		
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////
//      CEBhE쐬                          //
////////////////////////////////////////////////////////
static void Init_MainWnd()
{
	s_cWin = WINDOW_SetStdInfo( TEXT("WAVE"), WINDOW_TITLE, enWindowTypeStandard, MainWndProc, stgl.hInst, WINDOW_W, WINDOW_H );
	WINDOW_Create( s_cWin );
	
	WINDOW_Update( s_cWin, SW_SHOW );

	// t@Chbv/s
	DragAcceptFiles( s_cWin.m_hWnd, TRUE );
	
	// ^Cgo[̃ACR
	SetClassLong( s_cWin.m_hWnd, GCL_HICON, (long)LoadIcon( stgl.hInst, (LPTSTR)IDI_ICON1 ) );
	
	Init_ChildWnd();
//	Init_SystemMenu();
	
	Data_Initialize();	///< f[^̏.
	
}


////////////////////////////////////////////////////////
//      qEBhE̍쐬                            //
////////////////////////////////////////////////////////
static void Init_ChildWnd()
{
	HWND	hTmp;
	char	str[256];
	
	
	stgl.hFont = CreateFont( 12, 0, 0, 0, FW_EXTRALIGHT, FALSE, FALSE, 0, SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "lr SVbN" );
	
	stgl.hStart = CreateWindow( "BUTTON","eXg",
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		WINDOW_W-100, 14, 80, 20,
		s_cWin.m_hWnd, (HMENU)BTN_START, stgl.hInst, NULL );
	SendMessage( stgl.hStart, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	
#if 0
	stgl.hRefer = CreateWindow( "BUTTON","o",
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		WINDOW_W-180, 14, 60, 20,
		s_cWin.m_hWnd, (HMENU)BTN_REFER, stgl.hInst, NULL );
	SendMessage( stgl.hRefer, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
#endif
	
	wsprintf( str, "%d", iVolPerFrame );
	stgl.hOffSet = CreateWindowEx( WS_EX_CLIENTEDGE,"EDIT", str,
		WS_CHILD | WS_VISIBLE | ES_RIGHT,
		275, 15, 40, 18,
		s_cWin.m_hWnd, NULL, stgl.hInst, NULL );
	SendMessage( stgl.hOffSet, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	hTmp = CreateWindow( "STATIC","60/",
		WS_CHILD | WS_VISIBLE | SS_RIGHT,
		250, 15, 8*3, 18,
		s_cWin.m_hWnd, NULL, stgl.hInst, NULL );
	SendMessage( hTmp, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	hTmp = CreateWindow( "STATIC","frame",
		WS_CHILD | WS_VISIBLE | SS_RIGHT,
		315, 15, 8*5, 18,
		s_cWin.m_hWnd, NULL, stgl.hInst, NULL );
	SendMessage( hTmp, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	
	
	stgl.hFileNum = CreateWindowEx( WS_EX_CLIENTEDGE,"COMBOBOX","",
		WS_CHILD | WS_VISIBLE | WS_BORDER | CBS_DROPDOWNLIST | CBS_DISABLENOSCROLL,
		15, 15, 112, 20*4,
		s_cWin.m_hWnd, (HMENU)BTN_FILEUP, stgl.hInst, NULL );
	SendMessage( stgl.hFileNum, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	SendMessage( stgl.hFileNum, CB_ADDSTRING, 0, (long)"ϒlƂ" );
	SendMessage( stgl.hFileNum, CB_ADDSTRING, 0, (long)"őlƂ" );
	SendMessage( stgl.hFileNum, CB_ADDSTRING, 0, (long)"PQlƂ" );
	SendMessage( stgl.hFileNum, CB_SETCURSEL, eKind, 0 );
	
	wsprintf( str, "%d", iPer );
	stgl.hLength = CreateWindowEx( WS_EX_CLIENTEDGE,"EDIT", str,
		WS_CHILD | WS_VISIBLE | ES_RIGHT,
		135, 15, 40, 20,
		s_cWin.m_hWnd, NULL, stgl.hInst, NULL );
	SendMessage( stgl.hLength, WM_SETFONT, (WPARAM)stgl.hFont, MAKELPARAM(FALSE,0) );
	
}


////////////////////////////////////////////////////////
//      VXej[ݒ                          //
////////////////////////////////////////////////////////
static void Init_SystemMenu()
{
	HMENU	hMenu;
	
	hMenu = GetSystemMenu( s_cWin.m_hWnd,FALSE );
	
}


////////////////////////////////////////////////////////////////
//      C[`ɂ悤I                          //
////////////////////////////////////////////////////////////////
static long FAR PASCAL MainWndProc( HWND hWnd, UINT message, UINT wParam, LONG lParam )
{
	switch( message )
	{
		//	^C}[Ń|Xg(IWi)
		case TIMER_LOOP:
			if( StartTimerLoop( hWnd ) == FALSE )
			{
				TimerStop();
			}
			stgl.TimerFlag = FALSE;
			break;
			
		//EBhE쐬(\O)
		case WM_CREATE:
			MyWmCreate( hWnd );
			break;
			
		//EBhEĕ`掞
		case WM_PAINT:
			MyWmPaint( hWnd );
			break;
			
		//WindowsI
		case WM_QUERYENDSESSION:
			MyWmClose( hWnd );
			return 1L;
			
		//AvP[VI
		case WM_CLOSE:
			DestroyWindow( hWnd );
			WAVE_play(NULL);
			break;
			
		//EBhE̔j
		case WM_DESTROY:
			MyWmClose( hWnd );
			PostQuitMessage( 0 );
			break;
			
		//t@Chbvꂽ
		case WM_DROPFILES:
			MyWmDropFiles( hWnd,(HDROP)wParam );
			break;
			
		//R}h͂ꂽ
		case WM_COMMAND:
			MyWmCommand( hWnd,wParam,lParam );
			break;
			
		default:
			return DefWindowProc( hWnd,message,wParam,lParam );
	}
	
	return 0L;
}


//======================================================
//		EBhE쐬								
//======================================================
static void MyWmCreate( HWND hWnd ){
	
	Read_profile();
	
}


//======================================================
//		EBhE								
//======================================================
static void MyWmClose( HWND hWnd ){
	
	DeleteObject( stgl.hFont );
	
	Data_get();
	write_profile();
	
}


//======================================================
//		EBhEĕ`掞								
//======================================================
static void MyWmPaint( HWND hWnd )
{
	PAINTSTRUCT		ps;
	
	
	BeginPaint( hWnd,( LPPAINTSTRUCT )&ps );
	
	Draw_Picture( ps.hdc, 10, 0 );
	
	EndPaint( hWnd,( LPPAINTSTRUCT )&ps );
	
}


//**********************************************
//		t@Cݒ
//**********************************************
static void	set_file(int ii,char *name)
{
	
}


//********************************************************************************************
/**
 * @brief		Kind̎擾.
 * @author		N.Takeda
 * @date		2011/06/15() 21:01:23
 *
 * @return		EnDataKind	
 */
//********************************************************************************************
WAVEVOL::EnDataKind	GetKind(){	return eKind;	}


//********************************************************************************************
/**
 * @brief		readSwb֐.
 * @author		N.Takeda
 * @date		2011/06/15() 15:49:19
 *
 * @param[in]	const char*	_szPath	.
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static void	readSwb( const char *_szPath )
{
	enum{ enBuffMax = 1024 };
	char	sParam[ enBuffMax ];
	char	*pMem = NULL;
	Int32	ii, iLen = 0;
	
	iLen = MEM_TargetRead( &pMem, _szPath );
	if( 0 >= iLen )	return;
	
	iLen = FILT_deleteREM( pMem, iLen );
	iLen = FILT_excessiveSPACE( pMem, iLen );
	
	char	*pPtr = STRING_str2( pMem, "[script]" );
	pPtr = STRING_str2( pPtr, "utter", iLen - (pPtr-pMem) );
	pPtr += STRING_len( "utter" );
	
	for( ii=0 ; ii<iLen - (pPtr-pMem) ; ii++ )
	{
		if( ii >= enBuffMax )	break;
		if( ' ' > *(pPtr + ii) )	break;
		sParam[ ii ] = *(pPtr + ii);
	}
	sParam[ ii ] = '\0';
	
	CEzParam	cParam( sParam );
	
	eKind = static_cast<WAVEVOL::EnDataKind>(cParam.GetIntOption( 't', static_cast<Int32>(eKind) ) );
	iVolPerFrame = (60 / cParam.GetIntOption( 'f', 60 / iVolPerFrame ));
	iPer = cParam.GetIntOption( 'p', iPer );
	
	del_alloc( pMem );
	
	Data_show();
	
}


//======================================================
//		t@ChbOꂽ
//======================================================
static void MyWmDropFiles( HWND _hWnd, HDROP _hDrop )
{
	char		szName[ _MAX_PATH ], sDrive[ _MAX_DRIVE ], sDir[ _MAX_DIR ], sName[ _MAX_FNAME ], sExt[ _MAX_EXT ];
	POINT		pt;
	
	
	/// t@Chbvꂽʒu擾.
	if( DragQueryPoint( _hDrop, &pt ) == FALSE ) return;
	
	stgl.entry = DragQueryFile( _hDrop, 0xFFFFFFFF, NULL, 0 );
	
	if( stgl.entry == 1 )
	{
		/// binf[^ǂݍ.
		
		DragQueryFile( _hDrop, 0, szName, sizeof(szName) );
		
		
		FILE_split( szName, sDrive, sDir, sName, sExt );
		
		if( 0 == STRING_cmp2( sExt, ".swb" ) )
		{
			readSwb( szName );
			return;
		}
		
		/// ^[Qbgt@Cۑ.
		STRING_cpy( s_sTargetFileName, szName );
		
#if 0
		/// wavRo[gver.
		s_iLengthVolume = cWavVol.ConvWav2Vol( s_sTargetFileName, &s_pMemVolume, &s_iSizVolume, iVolPerFrame, iPer, eKind );
#endif
		FILE_merge( szName, sDrive, sDir, sName, ".bin" );
		ReadData( szName );
		
#if 1
		{
			/// wavx邽߂̕ϊ. oCi[f[^͎gpĂȂ.
			char	*pMem = NULL;	///< {[f[^obt@.
			int		iSizVolume = 0;	///< {[f[^TCY.
			
			iSizVolume = cWavVol.ConvWav2Vol( s_sTargetFileName, NULL, 0, iVolPerFrame, iPer, eKind );
			mem_alloc( char, pMem, iSizVolume );
			cWavVol.ConvWav2Vol( s_sTargetFileName, pMem, iSizVolume, iVolPerFrame, iPer, eKind );
			
			/// oCi[f[^͂j.
			del_alloc( pMem );
			
			HDC		DC;
			DC = GetDC( _hWnd );
			VolDraw( DC, 20, 200, cWavVol.GetWave() );
			InfoDraw( DC, 20, 40 );
			ReleaseDC( _hWnd, DC );
		}
#endif
		
	}
	
	WAVE_play( NULL );
	TimerStop();
	
}


//======================================================
//		R}h
//======================================================
static void MyWmCommand( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	switch( LOWORD(wParam) )
	{
		/*-----{^-----*/
		/*eXg{^ꂽ*/
		case BTN_START:
			TimerStop();
			Push_start( hWnd );
			break;
			
#if 0
		/*Qƃ{^ꂽ*/
		case BTN_REFER:
			out_volume();
			break;
#endif
			
		/*vpeB{^ꂽ*/
		case BTN_PROPERTY:
			break;
			
	}
	
}




////////////////////////////////////////////////////////////////////////////////
//		֐																	
////////////////////////////////////////////////////////////////////////////////
// -----BMP
//======================================================
//		BMP`											
//======================================================
static void Draw_Picture( HDC DC,int X,int Y)
{
	HDC 		MemDC;
	
	
	MemDC = CreateCompatibleDC( DC );
	
	VolDraw( DC, 20, 200, cWavVol.GetWave() );
	InfoDraw( DC, 20, 40 );
	
	DeleteDC( MemDC );
	
}


// -----f[^
//======================================================
//		f[^̏									
//======================================================
static void Data_Initialize()
{
	
	stgl.entry = 0;
	
}


//********************************************************************************************
/**
 * @brief		eGfBbgEBhEɒlZbg.
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
void	Data_show()
{
	char	str[256];
	
	
	wsprintf( str, "%d", iVolPerFrame );
	SetWindowText( stgl.hOffSet,str );
	
	wsprintf( str, "%d", iPer );
	SetWindowText( stgl.hLength, str );
	
	SendMessage( stgl.hFileNum, CB_SETCURSEL, eKind, 0 );
	
}


//********************************************************************************************
/**
 * @brief		eGfBbgEBhEɃZbgĂf[^擾
 * @author		N.Takeda
 *
 * @return		Ȃ (none)
 */
//********************************************************************************************
static void	Data_get()
{
	char	str[80];
	
	
	GetWindowText( stgl.hOffSet, str, sizeof(str) );
	iVolPerFrame = atoi(str);
	
	GetWindowText( stgl.hLength, str, sizeof(str) );
	iPer = atoi(str);
	
	eKind = static_cast<WAVEVOL::EnDataKind>(SendMessage( stgl.hFileNum, CB_GETCURSEL, 0, 0 ));
	
}




// -----Jn
//======================================================
//		Jn{^ꂽ
//======================================================
static void Push_start( HWND hWnd )
{
	HDC		DC;
	
	
	Data_get();
	
	WAVE_play( s_sTargetFileName );
	
	DC = GetDC( hWnd );
	
	VolDraw( DC, 20, 200, cWavVol.GetWave() );
	InfoDraw( DC, 20, 40 );
	
	ReleaseDC( hWnd, DC );
	
	iSyncFrm = 0;
	TimerStart( s_cWin.m_hWnd );
	
}


//======================================================
//		Jñ^C}[							
//======================================================
static BOOL StartTimerLoop( HWND hWnd )
{
	HDC		DC;
	
	
	DC = GetDC(hWnd);
	
	Update( iSyncFrm );
	
	iSyncFrm++;
	if( iSyncFrm >= s_iLengthVolume )
	{
		TextOut( DC, 21, 260, "                   " );
		return FALSE;	//	I
	}
	
	BarDraw( DC, 20, 200, iSyncFrm );
	
	int	a = GetVolData(iSyncFrm);
	     if(a<40)	TextOut( DC,21, 260, "          ");
	else if(a<80)	TextOut( DC,21, 260, "O         ");
	else if(a<110)	TextOut( DC,21, 260, "OO        ");
	else if(a<140)	TextOut( DC,21, 260, "OOO       ");
	else if(a<180)	TextOut( DC,21, 260, "OOOO      ");
	else if(a<200)	TextOut( DC,21, 260, "OOOOO     ");
	else if(a<256)	TextOut( DC,21, 260, "OOOOOO    ");
	
	ReleaseDC( hWnd,DC );
	
	return TRUE;
}


// -----ݒt@C
//======================================================
//		ftHgݒǂݍ݂܂					
//======================================================
static void Read_profile()
{
	
	iVolPerFrame	= PROFILE_GetInt( TEXT("INIT"), TEXT("volperframe"),	1 );
	eKind			= static_cast<WAVEVOL::EnDataKind>(PROFILE_GetInt( TEXT("INIT"), TEXT("kind"),	WAVEVOL::enDataKindBiggest ));
	iPer			= PROFILE_GetInt( TEXT("INIT"), TEXT("per"),			0 );
	
}


//======================================================
//		ftHgݒ݂܂					
//======================================================
void	write_profile()
{
	
	PROFILE_SetInt( TEXT("INIT"),TEXT("volperframe"),	iVolPerFrame );
	PROFILE_SetInt( TEXT("INIT"),TEXT("kind"),			static_cast<Int32>(eKind) );
	PROFILE_SetInt( TEXT("INIT"),TEXT("per"),			iPer );
	
}


// -----{^\^\
//======================================================
//		{^\^\								
//======================================================
static void Button_enable( BOOL show )
{
	
	EnableWindow( stgl.hDecode, show );
	EnableWindow( stgl.hProperty, show );
	
}


// -----^C}[
//======================================================
//		x^C}[Jn܂						
//======================================================
static void TimerStart( HWND hWnd )
{
	TIMECAPS	caps;
	
	stgl.TimerFlag = FALSE;
	stgl.TimerID = 0;
	
	timeGetDevCaps( &caps,sizeof(caps) );
	timeBeginPeriod( caps.wPeriodMin );
	
	//elay Cxgx~bŎw肵܂B̒lA^C}ŃT|[gCxgx̍ŏlől܂ł͈̔͂ɂȂꍇA֐̓G[Ԃ܂B 
	stgl.TimerID = timeSetEvent( (int)(16.66666667f*(float)iVolPerFrame), caps.wPeriodMin, TimerFunc, (DWORD)hWnd, (UINT)TIME_PERIODIC );
	//	iSyncFrm
	
}


//======================================================
//		^C}[R[obN֐						
//======================================================
static void CALLBACK TimerFunc( UINT wID, UINT wUser, DWORD dwUser, DWORD dw1, DWORD dw2 )
{
	HWND	hWnd = (HWND)dwUser;
	
	if( stgl.TimerFlag == FALSE )
	{
		stgl.TimerFlag = TRUE;
		PostMessage( hWnd,TIMER_LOOP,0,0 );
	}
}


//======================================================
//		x^C}[~܂						
//======================================================
static void TimerStop()
{
	TIMECAPS	caps;
	
	if( stgl.TimerID != 0 )
	{
		timeKillEvent( stgl.TimerID );
		stgl.TimerID = 0;
		timeGetDevCaps( &caps,sizeof(caps) );
		timeEndPeriod( caps.wPeriodMin );
		stgl.TimerFlag = FALSE;
		
	}
}





//
void	InfoDraw()
{
	if( cWavVol.GetMono1Stereo2() == 1 ){	_str("Mono");}
	else{									_str("Stereo");}
	
	DEBUG_printf( "d.txt", "Sampling Freq:%6d",	cWavVol.GetSamplingFreq() );
	DEBUG_printf( "d.txt", "Bit Length:%3d",	cWavVol.GetBitLength() );
	DEBUG_printf( "d.txt", "Total Bytes:%8d",	cWavVol.GetTotalBytes() );
	DEBUG_printf( "d.txt", "Time Length:%7.4f",	(double)cWavVol.GetWaveSize() / (double)cWavVol.GetSamplingFreq() );
	
}


void	InfoDraw( HDC DC, int x1, int y1 )
{
	char	sTmpChar[12];
	
	if( cWavVol.GetMono1Stereo2() == 1 )	TextOut( DC,x1 + 10, y1 + 10, "Mono");
	else								TextOut( DC,x1 + 10, y1 + 10, "Stereo");
	
	TextOut( DC,x1 + 80, y1 + 10, "Sampling Freq" );
	sprintf( sTmpChar, "%6d", cWavVol.GetSamplingFreq() );
	TextOut( DC,x1 + 80, y1 + 30, sTmpChar );
	
	TextOut( DC,x1 + 200, y1 + 10, "Bit Length" );
	sprintf( sTmpChar, "%3d", cWavVol.GetBitLength() );
	TextOut( DC,x1 + 200, y1 + 30, sTmpChar );
	
	TextOut( DC,x1 + 300, y1 + 10, "Total Bytes" );
	sprintf( sTmpChar, "%8d", cWavVol.GetTotalBytes() );
	TextOut( DC,x1 + 300, y1 + 30, sTmpChar );
	
	TextOut( DC,x1 + 400, y1 + 10, "Time Length" );
	sprintf( sTmpChar, "%7.4f", (double)cWavVol.GetWaveSize() / (double)cWavVol.GetSamplingFreq() );
	TextOut( DC,x1 + 400, y1 + 30, sTmpChar );
	
}


//		
void	VolDraw( HDC DC, int x1, int y1, double* InW )
{
	HPEN	myPen;
	HPEN	pOldPen;
	
	int		ii;
	int		ytmp;
	RECT	rc;
	
	
	myPen = CreatePen( PS_DOT, 1, RGB(0,255,0) );
	pOldPen = (HPEN)SelectObject(DC,myPen);
	
	MoveToEx( DC,x1, y1,NULL);
	LineTo( DC,(int)(x1 + dotn * xstep), y1);
	
	MoveToEx( DC,x1, y1 - yframe,NULL);
	LineTo( DC,(int)(x1 + dotn * xstep), y1 - yframe);
	
	MoveToEx( DC,x1, y1 + yframe,NULL);
	LineTo( DC,(int)(x1 + dotn * xstep), y1 + yframe);
	
	
	rc.left 	=	x1;
	rc.top		=	y1 - yframe+1;
	rc.right	=	x1 + (int)(dotn * xstep);
	rc.bottom	=	y1 + yframe;
	FillRect( DC, &rc, (HBRUSH)GetStockObject( WHITE_BRUSH ));
	
	
	MoveToEx( DC,x1, y1 - yframe,NULL);
	LineTo( DC,x1, y1 + yframe);
	MoveToEx( DC,x1 + (int)(dotn * xstep / 2), y1 - yframe, NULL );
	LineTo( DC,x1 + (int)(dotn * xstep / 2), y1 + yframe );
	MoveToEx( DC,x1 + (int)(dotn * xstep), y1 - yframe, NULL );
	LineTo( DC,(int)(x1 + dotn * xstep), y1 + yframe );
	
	SelectObject( DC, pOldPen );
	DeleteObject( myPen );
	
	
	myPen = CreatePen( PS_SOLID, 1, RGB(0,0,255) );
	pOldPen = (HPEN)SelectObject( DC, myPen );
	
	
	if(InW == NULL)	return;
	
	
	for(ii=0 ; ii<dotn-2; ii++) {
		if( s_iLengthVolume <= ii )	break;
		
		//	n_
		MoveToEx(DC,x1+ii*1, y1 + 0,NULL);
		//	I_
		ytmp = (int)(GetVolData(ii+0))/2;
		if( ytmp > yframe ) ytmp = yframe;
		if( ytmp < -yframe ) ytmp = -yframe;
		LineTo(DC,  x1+ii*1, y1 - ytmp);
		
	}
	
	SelectObject(DC,pOldPen);
	DeleteObject(myPen);
	
}



//		Điso[
void	BarDraw(HDC DC, int x1, int y1,int ii)
{
	HPEN	myPen;
	HPEN	pOldPen;
	
	
	myPen = CreatePen(PS_SOLID, 1, RGB(255,0,0));
	pOldPen = (HPEN)SelectObject(DC,myPen);
	
	//	n_
	MoveToEx(DC,x1, y1 + 10,NULL);
	//	I_
	LineTo(DC,  x1+ii, y1 + 10);
	
	SelectObject(DC,pOldPen);
	DeleteObject(myPen);
}
